'By Andreas Andersson 1998. E-Mail: alhambra5p@hotmail.com
'
'            Ŀ
'             Ŀ 
'              * AA Mouse for QBasic 1.0 *  
'              
'            
'                                      
'If you are using QuickBASIC 4.5, remember to load the quick library when
'starting up using the following command line: QB/ L.
'
'If you use any of this code in your programs, please give me a credit.
'
'Why AA Mouse for QBasic??
'       * Easy. AA Mouse uses functions to find out coordinates and button
'         events. All of the SUBS/ FUNCTIONS in AA Mouse includes informations
'         on how to use them.
'       * Big. I have still to seen any QBasic mouse program that includes all
'         of the AA Mouse functions. If you don't need them all, just delete
'         the unused SUBS/FUNCTIONS (I very much doubt that you will delete
'         the functions).
'       * AA Mouse are not using up any DATA statements. This makes the
'         RESTORE statement easier to use  and the main program more readable.
'
'Why NOT AA Mouse for QBasic???
'       * Tell me! AA Mouse is not tested on any other machine than my mums
'         where it works fine. Report bugs to: alhambra5p@hotmail.com
'
'
'At last I would like to give a credit to Mark K. Kim for his "Incorporating
'assembly into Basic" tutorial. Visit him at http://members.aol.com/vinDaci/.
'
'
'Begin code:

DEFINT A-Z      'Set intigers as default

'*** Declare subs and functions (delete the ones you don't need ***
DECLARE SUB MouseInit (AX)  'AX=0 : Initialize mouse AX=1 : Show AX=2 : Hide
DECLARE SUB MouseCrd (X, Y)     'Get the mousepointer to X, Y
DECLARE SUB MousePoint (UserDef) 'Set shape of pointer
DECLARE SUB MouseRange (X1, X2, Y1, Y2) 'Limit mouse movements
DECLARE FUNCTION MouseBtn ()    'Mousebutton (1 : Left  2 : Right  3 : Middle)
DECLARE FUNCTION MouseX ()      'Mouse X coordinate (For text mode: /8)
DECLARE FUNCTION MouseY ()      'Mouse Y coordinate (For text mode: /8)


'*** Screenmode 12: 640 * 480 * 16.  Clear screen ***
SCREEN 12               'SCREEN 9 is usable but the cursor menu text won't
CLS                     'fit into the buttons.


'***** Make the screen look nice *****

'*** Draw OFF-button ***
CIRCLE (90, 190), 50, 8, , , .5 'Draw ellipse with grey border
PAINT (90, 190), 4, 8           'Paint ellipse red
FOR Y = 183 TO 197              'Read graphics: OFF-text
        FOR X = 76 TO 105
                READ r
                PSET (X, Y), r
        NEXT X
NEXT Y

'*** Draw Mousecursor change and restore buttons ***
COLOR 7
LOCATE 10, 30: PRINT "Mouse cursor menu:"
LOCATE 12, 34: PRINT "C 1   C 2   C 3"
LINE (260, 172)-(291, 193), 14, B
LINE (308, 172)-(339, 193), 14, B
LINE (356, 172)-(387, 193), 14, B

'*** Draw a box to show where the mouse movement limits are ***
LINE (0, 144)-(400, 400), 14, B, &H4000

'*** Print some text ***
COLOR 10
LOCATE 1, 1: PRINT "Left click on the OFF-button or press ESC to exit."
COLOR 1
LOCATE 5, 5: PRINT "X: [   ] "
LOCATE 7, 5: PRINT "Y: [   ] "
LOCATE 9, 5: PRINT "Button: [      ]"
COLOR 12
LOCATE 20, 53: PRINT "AA Mouse for QBasic"
LOCATE 21, 53: PRINT "by Andreas Andersson 1998"



'***** Initialize,show and set mouse *****
MouseInit 0                     'Initialize
MouseCrd 90, 190                'Move mousepointer to X=90, Y=190 (OFF-button)
MouseInit 1                     'Show mousepointer
MouseRange 0, 144, 400, 400     'Limit mouse movements


'***** Main loop *****
DO
      '*** Test if any button is `clicked' ***
        IF MouseBtn = 1 THEN
                'Test for hit on OFF-button using colors 4, 8 and 15.
                IF POINT(MouseX, MouseY) = 4 THEN EXIT DO
                IF POINT(MouseX, MouseY) = 8 THEN EXIT DO
                IF POINT(MouseX, MouseY) = 15 THEN EXIT DO
               
                'Text for hit on change and restore mousecursor buttons using
                'coordinates.
                IF MouseY > 171 AND MouseY < 194 THEN
                        IF MouseX > 259 AND MouseX < 292 THEN MousePoint 1
                        IF MouseX > 307 AND MouseX < 340 THEN MousePoint 2
                        IF MouseX > 355 AND MouseX < 388 THEN MousePoint 3
                END IF

        END IF

        '*** Print coordinates and mousebutton status ***
        COLOR 10
        LOCATE 5, 9: PRINT USING "###"; MouseX          'X coordinate
        LOCATE 7, 9: PRINT USING "###"; MouseY          'Y coordinate
        LOCATE 9, 14
        IF MouseBtn = 0 THEN                            'No button
                PRINT "      "
        ELSEIF MouseBtn = 1 THEN                        'Left button
                PRINT "Left  "
        ELSEIF MouseBtn = 2 THEN                        'Right button
                PRINT "Right "
        ELSEIF MouseBtn = 3 THEN                        'Both buttons
                PRINT "Middle"
        END IF

LOOP UNTIL INKEY$ = CHR$(27)            'Loop until ESC is pressed


'***** Switch to text mode and turn off mouse. *****
SCREEN 0                'Screenmode 0
MouseInit (2)           'Hide mousepointer
END                     '???




'Graphics: OFF-text in button.
DATA 04,04,04,15,15,15,08,04,04,04,04,15,15,15,15,15,15,15,08,04,04,15,15,15,15,15,15,15,08,04
DATA 04,04,15,15,15,15,15,08,04,04,04,15,15,15,15,15,15,15,08,04,04,15,15,15,15,15,15,15,08,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 15,15,08,04,04,04,04,15,15,08,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 15,15,08,04,04,04,04,15,15,08,04,15,15,15,15,15,15,08,04,04,04,15,15,15,15,15,15,08,04,04
DATA 15,15,08,04,04,04,04,15,15,08,04,15,15,15,15,15,15,08,04,04,04,15,15,15,15,15,15,08,04,04
DATA 15,15,08,04,04,04,04,15,15,08,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 15,15,08,04,04,04,04,15,15,08,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,15,15,08,04,04,15,15,08,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,04,15,15,15,15,15,08,04,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04
DATA 04,04,04,15,15,15,08,04,04,04,04,15,15,08,04,04,04,04,04,04,04,15,15,08,04,04,04,04,04,04

'
'Returns mousebutton status as follows:
'       0 = Mousebutton not pressed
'       1 = Left mousebutton pressed
'       2 = Right mousebutton pressed
'       3 = Middle (or both, if only two buttons) mousebutton(s) pressed
'
FUNCTION MouseBtn


'% % % Machine code: Return mousebutton status % % %
asm$ = ""
asm$ = asm$ + CHR$(&H55)                                'push   bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov    bp,sp
asm$ = asm$ + CHR$(&HB8) + CHR$(&H3) + CHR$(&H0)        'mov    ax,03h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H89) + CHR$(&HD8)                   'mov    ax,bx
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov    bx,[bp+06h]
asm$ = asm$ + CHR$(&H89) + CHR$(&H7)                    'mov    [bx],ax
asm$ = asm$ + CHR$(&H5D)                                'pop    bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)        'retf   02h

DEF SEG = VARSEG(asm$)
CALL absolute(BX, SADD(asm$))

MouseBtn = BX

END FUNCTION

'
'Move mousepointer to specified position (X, Y)
'
SUB MouseCrd (X, Y)


'% % % Machine code: Set mouse X and Y coordinates % % %
asm$ = ""
asm$ = asm$ + CHR$(&H55)                                'push   bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov    bp,sp
asm$ = asm$ + CHR$(&HB8) + CHR$(&H4) + CHR$(&H0)        'mov    ax,4
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)       'mov    bx,[bp+08h]
asm$ = asm$ + CHR$(&H8B) + CHR$(&HF)                    'mov    cx,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov    bx,[bp+06h]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)                   'mov    dx,[bx]
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H5D)                                'pop    bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)        'retf   04h

DEF SEG = VARSEG(asm$)
CALL absolute(X, Y, SADD(asm$))

END SUB

'
'Initialize or turn on/off mousepointer
'       AX = 0  :  Initialize (Must be done before any other mouse operation)
'       AX = 1  :  Show mousepointer
'       AX = 2  :  Hide mousepointer
'
SUB MouseInit (AX)


'*** Initialize mouse ***

IF AX = 0 THEN
        '% % % Machine code: Find mousedriver % % %
        asm$ = ""                                       '#   Assembly   #
        asm$ = asm$ + CHR$(&H55)                         'push  bp
        asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)            'mov   bp,sp
        asm$ = asm$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H0) 'mov   ax,0000h
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)            'int   33h
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)'mov   bx,[bp+06h]
        asm$ = asm$ + CHR$(&H89) + CHR$(&H7)             'mov   [bx],ax
        asm$ = asm$ + CHR$(&H5D)                         'pop   bp
        asm$ = asm$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0) 'retf  02h

        DEF SEG = VARSEG(asm$)
        CALL absolute(AX, SADD(asm$))

        '*** If ax = 0 then no driver is installed ***
        IF AX = 0 THEN
                SCREEN 0: WIDTH 80: CLS
                PRINT "Mousedriver not found."
                END
        END IF



'*** Show or hide mousepointer ***

ELSEIF AX = 1 OR AX = 2 THEN

        '% % % Machine code: Show or hide mousepointer % % %
        asm$ = ""                                      '#    Assembly    #
        asm$ = asm$ + CHR$(&HB8) + CHR$(AX) + CHR$(&H0) 'mov    ax, n (=AX)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)           'int    33h
        asm$ = asm$ + CHR$(&HCB)                        'retf

        DEF SEG = VARSEG(asm$)
        CALL absolute(SADD(asm$))

END IF


END SUB

'
'Defines the shape of the mouse cursor
'
'The range of the argument passed into MousePoint depends on how many
'cursors there are. In this demo, the range is 0 to 3, where 0 restores the
'cursor. To add a cursor, just add a new CASE and put the cursor string data
'below. Note that the restore function restores the whole mousedriver except
'for the coordinates. If anyone happens to know any way to restore only the
'mousecursor, please drop me a mail.
'
'How to make a cursor:
'There is three things the mousedriver needs to know when making a new cursor.
'The screen mask, the cursor mask and the hot spot. The screen mask and the
'cursor mask is 16 bytes long each and make together the shape of the cursor.
'The hot spot is the coordinates where the mousepointer actually is. It's one
'byte long: X and Y coordinates.
'
'When making a cursor, you may think of it as divided into 16 Y-lines that is
'separated into four X segments. One X segment is defined by one hexadecimal.
'Four hexadecimals make one Y-line. This is because one X segment is four
'pixels, which means 16 different point combinations (see table below). From
'this you may have figured out that the cursor is 16 * 16 pixels.
'The screen mask is defined first, and sets black points. One X segment is
'defined as the table shows.
'
'Screen mask table:
'     Hexadecimal       Points set      0 = Black   - = Unchanged
'          0              0000
'          1              000-
'          2              00-0
'          3              00--
'          4              0-00
'          5              0-0-
'          6              0--0
'          7              0---
'          8              -000
'          9              -00-
'          A              -0-0
'          B              -0--
'          C              --00
'          D              --0-
'          E              ---0
'          F              ----
'
'
'The cursor mask is layered on the screen mask and produces white or inverted
'points. If a cursor mask point is placed on a screen mask point the output
'color will be white. If there is no screen mask point under the cursor mask
'point the output color will be inverted. This means there are four "colors"
'available: Unchanged + Unchanged = Transparent, Unchanged + White = Inverted,
'Black + Unchanged = Black and Black + White = White.
'
'Cursor mask table:
'     Hexadecimal       Points set   F = White/ Inverted    - = Unchanged
'          0              ----
'          1              ---F
'          2              --F-
'          3              --FF
'          4              -F--
'          5              -F-F
'          6              -FF-
'          7              -FFF
'          8              F---
'          9              F--F
'          A              F-F-
'          B              F-FF
'          C              FF--
'          D              FF-F
'          E              FFF-
'          F              FFFF
'
'One Y-line is formatted like this : &HPPPP   (where P = Point status)
'Because AA MousePoint uses strings in the mousedriver call, you must put
'the numbers in a string using MKI$(&HPPPP). Make 16 of these for the screen
'mask and 16 for the cursor mask. Then add the hotspot like this: BX% = &HX
'and CX% = &HY. The range for X or Y is &H0-&HF (or 0-15) where 0,0 is the
'upper left corner.
'
'Look at the examples below how to use it in a program.
'
SUB MousePoint (UserDef)


'***** Start mouse cursor selection *****

SELECT CASE UserDef

CASE 0          '*** Restore cursor ***

'% % % MACHINE CODE: Restore cursor % % %
asm$ = ""
asm$ = asm$ + CHR$(&HB8) + CHR$(&H3) + CHR$(&H0)        'mov    ax,0003h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H52)                                'push   dx
asm$ = asm$ + CHR$(&H51)                                'push   cx
asm$ = asm$ + CHR$(&HB8) + CHR$(&H2) + CHR$(&H0)        'mov    ax,0002h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H0)        'mov    ax,0000h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&HB8) + CHR$(&H4) + CHR$(&H0)        'mov    ax,0004h
asm$ = asm$ + CHR$(&H59)                                'pop    cx
asm$ = asm$ + CHR$(&H5A)                                'pop    dx
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&HB8) + CHR$(&H1) + CHR$(&H0)        'mov    ax,0001h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&HCB)                                'retf

DEF SEG = VARSEG(asm$)
CALL absolute(SADD(asm$))

EXIT SUB


        CASE 1          '*** Cursor 1 ***

        DX$ = ""
        'Screen mask
        DX$ = DX$ + MKI$(&HFFBF) + MKI$(&HFEDF) + MKI$(&HFEDF) + MKI$(&HFEDF)
        DX$ = DX$ + MKI$(&HFDEF) + MKI$(&HFDEF) + MKI$(&HFDEF) + MKI$(&HFBF7)
        DX$ = DX$ + MKI$(&HFBF7) + MKI$(&HFFF7) + MKI$(&HF7FB) + MKI$(&HF7FB)
        DX$ = DX$ + MKI$(&HF7FB) + MKI$(&HEFFD) + MKI$(&HEFFD) + MKI$(&HF7FE)
        'Cursor mask
        DX$ = DX$ + MKI$(&H180) + MKI$(&H7240) + MKI$(&H6240) + MKI$(&H5240)
        DX$ = DX$ + MKI$(&H420) + MKI$(&H420) + MKI$(&H420) + MKI$(&H810)
        DX$ = DX$ + MKI$(&H810) + MKI$(&HFF0) + MKI$(&H1008) + MKI$(&H1008)
        DX$ = DX$ + MKI$(&H1008) + MKI$(&H2004) + MKI$(&H2004) + MKI$(&H700E)
        'Hot spot X,Y
        BX% = &H0: CX% = &H0


        CASE 2          '*** Cursor 2 ***
       
        DX$ = ""
        'Screen mask
        DX$ = DX$ + MKI$(&HFFFF) + MKI$(&H8FFF) + MKI$(&H81FF) + MKI$(&H803F)
        DX$ = DX$ + MKI$(&H800F) + MKI$(&H800F) + MKI$(&H860F) + MKI$(&HC60F)
        DX$ = DX$ + MKI$(&HC00F) + MKI$(&HC007) + MKI$(&HC007) + MKI$(&HE200)
        DX$ = DX$ + MKI$(&HE200) + MKI$(&HFF00) + MKI$(&HFF03) + MKI$(&HFF83)
        'Cursor mask
        DX$ = DX$ + MKI$(&H0) + MKI$(&H0) + MKI$(&H2000) + MKI$(&H3C00)
        DX$ = DX$ + MKI$(&H2380) + MKI$(&H2060) + MKI$(&H1000) + MKI$(&H10C0)
        DX$ = DX$ + MKI$(&H1020) + MKI$(&H1320) + MKI$(&H890) + MKI$(&H890)
        DX$ = DX$ + MKI$(&H4E) + MKI$(&H40) + MKI$(&H38) + MKI$(&H0)
        'Hot spot X,Y
        BX% = &H0: CX% = &H0


        CASE 3          '*** Cursor 3 ***
      
        DX$ = ""
        'Screen mask
        DX$ = DX$ + MKI$(&HF83F) + MKI$(&HE00F) + MKI$(&HC007) + MKI$(&H8443)
        DX$ = DX$ + MKI$(&H8C63) + MKI$(&H1C71) + MKI$(&H381) + MKI$(&H381)
        DX$ = DX$ + MKI$(&H381) + MKI$(&H1C71) + MKI$(&H8C63) + MKI$(&H8443)
        DX$ = DX$ + MKI$(&HC007) + MKI$(&HE00F) + MKI$(&HF83F) + MKI$(&HFFFF)
        'Cursor mask
        DX$ = DX$ + MKI$(&H0) + MKI$(&H7C0) + MKI$(&H1930) + MKI$(&H2108)
        DX$ = DX$ + MKI$(&H2108) + MKI$(&H4004) + MKI$(&H4004) + MKI$(&H783C)
        DX$ = DX$ + MKI$(&H4004) + MKI$(&H4004) + MKI$(&H2108) + MKI$(&H2108)
        DX$ = DX$ + MKI$(&H1930) + MKI$(&H7C0) + MKI$(&H0) + MKI$(&H0)
        'Hot spot X,Y
        BX% = &H7: CX% = &H7

END SELECT

'***** End mouse cursor selection *****



'% % % MACHINE CODE: Change mousecursor % % %
asm$ = ""                                            '# Assembly translation #
asm$ = asm$ + CHR$(&H55)                                'push   bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov    bp,sp
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC)       'mov    bx,[bp+0Ch]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H7)                    'mov    ax,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA)       'mov    bx,[bp+0Ah]
asm$ = asm$ + CHR$(&H8B) + CHR$(&HF)                    'mov    cx,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)       'mov    bx,[bp+08h]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)                   'mov    dx,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov    bx,[bp+06h]
asm$ = asm$ + CHR$(&H8E) + CHR$(&H7)                    'mov    es,[bx]
asm$ = asm$ + CHR$(&H89) + CHR$(&HC3)                   'mov    bx,ax
asm$ = asm$ + CHR$(&HB8) + CHR$(&H9) + CHR$(&H0)        'mov    ax,0009h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H5D)                                'pop    bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H8) + CHR$(&H0)        'retf   08h


ES% = VARSEG(DX$)
DEF SEG = VARSEG(asm$)
CALL absolute(BX%, CX%, SADD(DX$), ES%, SADD(asm$))


END SUB

'
'Defines the area in which the mouse can be moved.
'X1, Y1 is the upper left corner.
'X2, Y2 is the lower right corner.
'
SUB MouseRange (X1, Y1, X2, Y2)


'% % % MACHINE CODE: Set mouse movement range % % %
asm$ = ""                                               '#    Assembly    #
asm$ = asm$ + CHR$(&H55)                                'push   bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov    bp,sp
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC)       'mov    bx,[bp+0Ch]
asm$ = asm$ + CHR$(&H8B) + CHR$(&HF)                    'mov    cx,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA)       'mov    bx,[bp+0Ah]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)                   'mov    dx,[bx]
asm$ = asm$ + CHR$(&HB8) + CHR$(&H7) + CHR$(&H0)        'mov    ax,07h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)       'mov    bx,[bp+08h]
asm$ = asm$ + CHR$(&H8B) + CHR$(&HF)                    'mov    cx,[bx]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov    bx,[bp+06h]
asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)                   'mov    dx,[bx]
asm$ = asm$ + CHR$(&H40)                                'inc    ax
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int    33h
asm$ = asm$ + CHR$(&H5D)                                'pop    bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H8) + CHR$(&H0)        'retf   08h


DEF SEG = VARSEG(asm$)
CALL absolute(X1, X2, Y1, Y2, SADD(asm$))


END SUB

'
'Returns the mouse X coordinate
'
'For info on screenmodes, press PgDn
'
FUNCTION MouseX


'% % % Machine code: Get mouse X coordinate % % %
asm$ = ""
asm$ = asm$ + CHR$(&H55)                                'push bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov bp,sp
asm$ = asm$ + CHR$(&HB8) + CHR$(&H3) + CHR$(&H0)        'mov ax,03h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int 33h
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov bx,[bp+06h]
asm$ = asm$ + CHR$(&H89) + CHR$(&HF)                    'mov [bx],cx
asm$ = asm$ + CHR$(&H5D)                                'pop bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)        'retf 02h

DEF SEG = VARSEG(asm$)
CALL absolute(CX, SADD(asm$))



'***** SCREENMODE INFO *****
'*** Text mode (SCREEN 0): MouseX = CX / 8 + 1 ***
'*** Graphics mode       : MouseX = CX         ***

MouseX = CX

END FUNCTION

'
'Returns the mouse Y coordinate
'
'For info on screenmodes, press PgDn
'
FUNCTION MouseY


'% % % Machine code: Get mouse Y coordinate % % %
asm$ = ""
asm$ = asm$ + CHR$(&H55)                                'push bp
asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)                   'mov bp,sp
asm$ = asm$ + CHR$(&HB8) + CHR$(&H3) + CHR$(&H0)        'mov ax,03h
asm$ = asm$ + CHR$(&HCD) + CHR$(&H33)                   'int 33h
asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)       'mov bx,[bp+06h]
asm$ = asm$ + CHR$(&H89) + CHR$(&H17)                   'mov [bx],dx
asm$ = asm$ + CHR$(&H5D)                                'pop bp
asm$ = asm$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)        'retf 02h

DEF SEG = VARSEG(asm$)
CALL absolute(DX, SADD(asm$))



'***** SCREENMODE INFO *****
'*** Text mode (SCREEN 0): MouseY = DX / 8 + 1 ***
'*** Graphics mode       : MouseY = DX         ***

MouseY = DX

END FUNCTION

